/* zumo Library
*/

#include "mbed.h"
#include "zumo.h"

zumo::zumo(PinName nrst, PinName tx, PinName rx) : _nrst(nrst), _ser(tx, rx)  {
    _ser.baud(57600);
    reset();
}

zumo::zumo():  _nrst(p23), _ser(p9, p10){
        _ser.baud(57600);
    }   


void zumo::reset () {
}


void zumo::stop (void) {
    _ser.putc(SEND_MOTOR_STOP);
    _ser.getc();
    
}

char zumo::speed(short spg,short spd){
    char v;
    _ser.putc(SEND_MOTOR_SPEED);
    _ser.putc(spg&0xff);
    _ser.putc((spg>>8)&0xff);
    _ser.putc(spd&0xff);
    _ser.putc((spd>>8)&0xff);
    v=_ser.getc();
    return v;
}

// angle envoyé au centime de deg  rot  et sens trigo
char zumo::rotate_speed_gyro_wait (short spd,short rot){
    char v;
    _ser.putc(SEND_ROTATE_GYRO);
    _ser.putc(spd&0xff);
    _ser.putc((spd>>8)&0xff);
    _ser.putc(rot&0xff);
    _ser.putc((rot>>8)&0xff);
    v=_ser.getc();
    v=_ser.getc();
    return v;
}

char zumo::Calibrate_line_sensor_wait (){
    char v;
    _ser.putc(SEND_CALIBRE_LIGNE);
    v=_ser.getc(); //accusé commande prise
    v=_ser.getc(); // accusé commande terminée
    return v;
}


char zumo::read_data_wait (char whatdata,char*tab){
    char v;
    _ser.putc(SEND_ROTATE_GYRO);
    _ser.putc(whatdata&0xff);
    v=_ser.getc();
/*#define DATA_SENSOR_GYRO    0x12
#define DATA_SENSOR_MEANDIST  0x24
#define DATA_SENSOR_LRDIST   0x38
#define DATA_SENSOR_LIGNE 0x42
#define DATA_SENSOR_LIGNE_5BIT 0x51
#define DATA_SENSOR_OBSTACLE 0x62*/
    v=v&0x0F;
    if(v!=0){
        for(char i=0;i<v;i++){
                tab[i]= _ser.getc();
        }
        return 0x0A;
    // retour de donnée
    }else{
        return 0x0E;
    }   
}


// avance tout droit de dist mm  limite de 3000mm
 // avec speed positif (car calcul sens par dist)
 // angle envoyé au centime de deg  rot  et sens trigo
char zumo::avance_wait(short spd, short dist){
    char v;
    if(dist<=3000) {
            _ser.putc(SEND_AVANCE);
            _ser.putc(spd&0xff);
            _ser.putc((spd>>8)&0xff);
            _ser.putc(dist&0xff);
            _ser.putc((dist>>8)&0xff);
            v=_ser.getc();
            v=_ser.getc(); // 0x0B  bloquant jusqu'à fin trajectoire
            return v;
    }else{
        return (0x0E);
    }
}

float zumo::battery() {
   
}


float zumo::line_position() {
    
}

void zumo::calibrated_sensors(unsigned short ltab[5]) {
    
}


void zumo::PID_start(int max_speed, int a, int b, int c, int d) {
    
}

void zumo::PID_stop() {
    
}



void zumo::leds(int val) {

}

